var Te = Object.defineProperty;
var _e = (a, e, t) => e in a ? Te(a, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : a[e] = t;
var F = (a, e, t) => (_e(a, typeof e != "symbol" ? e + "" : e, t), t);
const S = globalThis.process ?? { env: {}, versions: {} }, re = { ...S == null ? void 0 : S.env }, Be = {
  // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore
  node: "unknown",
  ...S == null ? void 0 : S.versions
};
S == null || S.platform;
S == null || S.arch;
class k extends Error {
  constructor(t, s) {
    super(t);
    F(this, "code");
    F(this, "stack");
    F(this, "context");
    this.context = s, s instanceof Error && (this.name = s.name, this.stack = s.stack, "code" in s && typeof s.code == "string" && (this.code = s.code));
  }
}
const Ee = [
  {
    url: "{scheme}://{host}{basePath}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api.browserstack.com"
      },
      basePath: {
        default: "/5"
      }
    }
  },
  {
    url: "{scheme}://{host}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api-cloud.browserstack.com"
      }
    }
  }
], Fe = "browserstack-client", Ue = "3.0.0-next.15", ze = "BrowserStack APIs client library for node.js", $e = "module", Le = "./dist/browserstack-client.umd.cjs", Oe = {
  "browserstack-local": "./dist/node/browserstack-local.cjs"
}, Me = "./dist/browserstack-client.js", We = "./dist/types/index.d.ts", He = {
  ".": {
    types: "./dist/types/index.d.ts",
    import: "./dist/browserstack-client.js",
    require: "./dist/browserstack-client.umd.cjs"
  },
  "./node": {
    types: "./dist/node/types/index.node.d.ts",
    import: "./dist/node/browserstack-client.js",
    require: "./dist/node/browserstack-client.cjs"
  },
  "./package.json": "./package.json",
  "./*": "./dist/*"
}, Ke = {
  prebuild: "node build.mjs && npm run lint",
  build: "tsc && vite build && vite build --config vite.config.node.ts",
  test: "vitest run --typecheck",
  "test-watch": "vitest --typecheck",
  coverage: "vitest run --coverage.enabled --coverage.include=src --coverage.exclude=src/generated",
  lint: "eslint . --ext .ts",
  "predocs:dev": "typedoc",
  "docs:dev": "vitepress dev docs",
  "predocs:build": "typedoc",
  "docs:build": "vitepress build docs",
  "docs:preview": "vitepress preview docs"
}, Ne = "Shirish Kamath", Je = "MIT", Ve = [
  "dist/**/*",
  "*.d.ts"
], Xe = {
  node: ">=18.0.0"
}, Qe = {
  "@apidevtools/swagger-parser": "^10.1.0",
  "@types/node": "^20.11.19",
  "@types/write-file-atomic": "^4.0.3",
  "@typescript-eslint/eslint-plugin": "^7.0.1",
  "@typescript-eslint/parser": "^7.0.1",
  "@vitest/coverage-v8": "1.2.1",
  eslint: "^8.56.0",
  "openapi-typescript": "^7.0.0-next.7",
  "openapi-typescript-helpers": "^0.0.7",
  typedoc: "^0.25.8",
  "typedoc-plugin-markdown": "^4.0.0-next.43",
  "typedoc-vitepress-theme": "^1.0.0-next.9",
  typescript: "^5.3.3",
  vite: "^5.1.3",
  "vite-plugin-dts": "^3.7.2",
  vitepress: "^1.0.0-rc.43",
  vitest: "1.2.1"
}, Ye = {
  fflate: "^0.8.2",
  "openapi-fetch": "^0.9.2",
  "write-file-atomic": "^5.0.1"
}, Ze = {
  type: "git",
  url: "git://github.com/shirish87/browserstack-client.git"
}, et = "https://shirish87.github.io/browserstack-client/", tt = {
  url: "https://github.com/shirish87/browserstack-client/issues"
}, st = [
  "browserstack",
  "api",
  "client",
  "node",
  "javascript",
  "typescript",
  "esm"
], j = {
  name: Fe,
  version: Ue,
  description: ze,
  type: $e,
  main: Le,
  bin: Oe,
  module: Me,
  types: We,
  exports: He,
  scripts: Ke,
  author: Ne,
  license: Je,
  files: Ve,
  engines: Xe,
  devDependencies: Qe,
  dependencies: Ye,
  repository: Ze,
  homepage: et,
  bugs: tt,
  keywords: st
}, rt = [j == null ? void 0 : j.name, j == null ? void 0 : j.version].filter(Boolean).join("/"), at = ["node", Be.node].filter(Boolean).join("/"), nt = [rt, at].filter(Boolean).join(" "), it = {
  name: j == null ? void 0 : j.name,
  version: j == null ? void 0 : j.version,
  userAgent: nt
}, ot = {
  "Content-Type": "application/json"
}, ut = /\{[^{}]+\}/g;
function ke(a) {
  let {
    baseUrl: e = "",
    fetch: t = globalThis.fetch,
    querySerializer: s,
    bodySerializer: r,
    headers: n,
    ...o
  } = { ...a };
  e.endsWith("/") && (e = e.substring(0, e.length - 1)), n = ve(ot, n);
  const u = [];
  async function d(p, l) {
    let {
      fetch: i = t,
      headers: c,
      params: g = {},
      parseAs: b = "json",
      querySerializer: y,
      bodySerializer: G = r ?? pt,
      ...P
    } = l || {}, B = typeof s == "function" ? s : ge(s);
    y && (B = typeof y == "function" ? y : ge({
      ...typeof s == "object" ? s : {},
      ...y
    }));
    const h = {
      redirect: "follow",
      ...o,
      ...P,
      headers: ve(n, c, g.header)
    };
    h.body && (h.body = G(h.body)), h.body instanceof FormData && h.headers.delete("Content-Type");
    let C = new Request(
      ct(p, { baseUrl: e, params: g, querySerializer: B }),
      h
    );
    const U = {
      baseUrl: e,
      fetch: i,
      parseAs: b,
      querySerializer: B,
      bodySerializer: G
    };
    for (const I of u)
      if (I && typeof I == "object" && typeof I.onRequest == "function") {
        C.schemaPath = p, C.params = g;
        const v = await I.onRequest(C, U);
        if (v) {
          if (!(v instanceof Request))
            throw new Error(
              "Middleware must return new Request() when modifying the request"
            );
          C = v;
        }
      }
    let f = await i(C);
    for (let I = u.length - 1; I >= 0; I--) {
      const v = u[I];
      if (v && typeof v == "object" && typeof v.onResponse == "function") {
        const E = await v.onResponse(f, U);
        if (E) {
          if (!(E instanceof Response))
            throw new Error(
              "Middleware must return new Response() when modifying the response"
            );
          f = E;
        }
      }
    }
    if (f.status === 204 || f.headers.get("Content-Length") === "0")
      return f.ok ? { data: {}, response: f } : { error: {}, response: f };
    if (f.ok)
      return b === "stream" ? { data: f.body, response: f } : { data: await f[b](), response: f };
    let z = await f.text();
    try {
      z = JSON.parse(z);
    } catch {
    }
    return { error: z, response: f };
  }
  return {
    /** Call a GET endpoint */
    async GET(p, l) {
      return d(p, { ...l, method: "GET" });
    },
    /** Call a PUT endpoint */
    async PUT(p, l) {
      return d(p, { ...l, method: "PUT" });
    },
    /** Call a POST endpoint */
    async POST(p, l) {
      return d(p, { ...l, method: "POST" });
    },
    /** Call a DELETE endpoint */
    async DELETE(p, l) {
      return d(p, { ...l, method: "DELETE" });
    },
    /** Call a OPTIONS endpoint */
    async OPTIONS(p, l) {
      return d(p, { ...l, method: "OPTIONS" });
    },
    /** Call a HEAD endpoint */
    async HEAD(p, l) {
      return d(p, { ...l, method: "HEAD" });
    },
    /** Call a PATCH endpoint */
    async PATCH(p, l) {
      return d(p, { ...l, method: "PATCH" });
    },
    /** Call a TRACE endpoint */
    async TRACE(p, l) {
      return d(p, { ...l, method: "TRACE" });
    },
    /** Register middleware */
    use(...p) {
      for (const l of p)
        if (l) {
          if (typeof l != "object" || !("onRequest" in l || "onResponse" in l))
            throw new Error(
              "Middleware must be an object with one of `onRequest()` or `onResponse()`"
            );
          u.push(l);
        }
    },
    /** Unregister middleware */
    eject(...p) {
      for (const l of p) {
        const i = u.indexOf(l);
        i !== -1 && u.splice(i, 1);
      }
    }
  };
}
function X(a, e, t) {
  if (e == null)
    return "";
  if (typeof e == "object")
    throw new Error(
      "Deeply-nested arrays/objects aren’t supported. Provide your own `querySerializer()` to handle these."
    );
  return `${a}=${(t == null ? void 0 : t.allowReserved) === !0 ? e : encodeURIComponent(e)}`;
}
function be(a, e, t) {
  if (!e || typeof e != "object")
    return "";
  const s = [], r = {
    simple: ",",
    label: ".",
    matrix: ";"
  }[t.style] || "&";
  if (t.style !== "deepObject" && t.explode === !1) {
    for (const u in e)
      s.push(
        u,
        t.allowReserved === !0 ? e[u] : encodeURIComponent(e[u])
      );
    const o = s.join(",");
    switch (t.style) {
      case "form":
        return `${a}=${o}`;
      case "label":
        return `.${o}`;
      case "matrix":
        return `;${a}=${o}`;
      default:
        return o;
    }
  }
  for (const o in e) {
    const u = t.style === "deepObject" ? `${a}[${o}]` : o;
    s.push(X(u, e[o], t));
  }
  const n = s.join(r);
  return t.style === "label" || t.style === "matrix" ? `${r}${n}` : n;
}
function ye(a, e, t) {
  if (!Array.isArray(e))
    return "";
  if (t.explode === !1) {
    const n = { form: ",", spaceDelimited: "%20", pipeDelimited: "|" }[t.style] || ",", o = (t.allowReserved === !0 ? e : e.map((u) => encodeURIComponent(u))).join(n);
    switch (t.style) {
      case "simple":
        return o;
      case "label":
        return `.${o}`;
      case "matrix":
        return `;${a}=${o}`;
      case "spaceDelimited":
      case "pipeDelimited":
      default:
        return `${a}=${o}`;
    }
  }
  const s = { simple: ",", label: ".", matrix: ";" }[t.style] || "&", r = [];
  for (const n of e)
    t.style === "simple" || t.style === "label" ? r.push(t.allowReserved === !0 ? n : encodeURIComponent(n)) : r.push(X(a, n, t));
  return t.style === "label" || t.style === "matrix" ? `${s}${r.join(s)}` : r.join(s);
}
function ge(a) {
  return function(t) {
    const s = [];
    if (t && typeof t == "object")
      for (const r in t) {
        const n = t[r];
        if (n != null) {
          if (Array.isArray(n)) {
            s.push(
              ye(r, n, {
                style: "form",
                explode: !0,
                ...a == null ? void 0 : a.array,
                allowReserved: (a == null ? void 0 : a.allowReserved) || !1
              })
            );
            continue;
          }
          if (typeof n == "object") {
            s.push(
              be(r, n, {
                style: "deepObject",
                explode: !0,
                ...a == null ? void 0 : a.object,
                allowReserved: (a == null ? void 0 : a.allowReserved) || !1
              })
            );
            continue;
          }
          s.push(X(r, n, a));
        }
      }
    return s.join("&");
  };
}
function lt(a, e) {
  let t = a;
  for (const s of a.match(ut) ?? []) {
    let r = s.substring(1, s.length - 1), n = !1, o = "simple";
    if (r.endsWith("*") && (n = !0, r = r.substring(0, r.length - 1)), r.startsWith(".") ? (o = "label", r = r.substring(1)) : r.startsWith(";") && (o = "matrix", r = r.substring(1)), !e || e[r] === void 0 || e[r] === null)
      continue;
    const u = e[r];
    if (Array.isArray(u)) {
      t = t.replace(
        s,
        ye(r, u, { style: o, explode: n })
      );
      continue;
    }
    if (typeof u == "object") {
      t = t.replace(
        s,
        be(r, u, { style: o, explode: n })
      );
      continue;
    }
    if (o === "matrix") {
      t = t.replace(
        s,
        `;${X(r, u)}`
      );
      continue;
    }
    t = t.replace(s, o === "label" ? `.${u}` : u);
  }
  return t;
}
function pt(a) {
  return JSON.stringify(a);
}
function ct(a, e) {
  var r;
  let t = `${e.baseUrl}${a}`;
  (r = e.params) != null && r.path && (t = lt(t, e.params.path));
  let s = e.querySerializer(e.params.query ?? {});
  return s.startsWith("?") && (s = s.substring(1)), s && (t += `?${s}`), t;
}
function ve(...a) {
  const e = new Headers();
  for (const t of a) {
    if (!t || typeof t != "object")
      continue;
    const s = t instanceof Headers ? t.entries() : Object.entries(t);
    for (const [r, n] of s)
      if (n === null)
        e.delete(r);
      else if (Array.isArray(n))
        for (const o of n)
          e.append(r, o);
      else
        n !== void 0 && e.set(r, n);
  }
  return e;
}
const [{ variables: J }, { variables: V }] = Ee ?? [], mt = `${J.scheme.default}://${J.host.default}${J.basePath ? J.basePath.default : ""}`, dt = `${V.scheme.default}://${V.host.default}${V.basePath ? V.basePath.default : ""}`;
class H {
  constructor(e) {
    F(this, "sdk");
    F(this, "sdkCloud");
    const t = e.username ?? re.BROWSERSTACK_USERNAME;
    if (e.usernameOptional !== !0 && (typeof t != "string" || !t.trim().length))
      throw new k("Missing options.username");
    const s = e.key ?? re.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new k("Missing options.key");
    const r = {
      ...e,
      baseUrl: e.baseUrl ?? mt,
      headers: {
        ...e.headers,
        Authorization: t ? `Basic ${btoa(`${t}:${s}`)}` : void 0,
        "User-Agent": it.userAgent
      }
    };
    this.sdk = ke(r), this.sdkCloud = ke({
      ...r,
      baseUrl: dt
    });
  }
  /**
   * @internal
   */
  async makeGetRequest(e, ...t) {
    const s = await this.sdk.GET(e, ...t);
    if (s.error || !s.data)
      throw new k("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePostRequest(e, ...t) {
    const s = await this.sdk.POST(e, ...t);
    if (s.error || !s.data)
      throw new k("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudGetRequest(e, ...t) {
    const s = await this.sdkCloud.GET(e, ...t);
    if (s.error || !s.data)
      throw new k("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudPostRequest(e, ...t) {
    const s = await this.sdkCloud.POST(e, ...t);
    if (s.error || !s.data)
      throw new k("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePutRequest(e, ...t) {
    const s = await this.sdk.PUT(e, ...t);
    if (s.error || !s.data)
      throw new k("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePatchRequest(e, ...t) {
    const s = await this.sdk.PATCH(e, ...t);
    if (s.error || !s.data)
      throw new k("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeDeleteRequest(e, ...t) {
    const s = await this.sdk.DELETE(e, ...t);
    if (s.error || !s.data)
      throw new k("Request failed", {
        path: e,
        response: s,
        ...t
      });
    return s.data;
  }
}
class ft extends H {
  /**
   * Constructs a new instance of the AppAutomateClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Retrieves the plan information for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the plan information.
   */
  getPlan(e) {
    return this.makeGetRequest("/app-automate/plan.json", e);
  }
  /**
   * Retrieves the list of devices available for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the list of devices.
   */
  getDevices(e) {
    return this.makeGetRequest("/app-automate/devices.json", e);
  }
  /**
   * Retrieves the projects from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects.
   */
  getProjects(e) {
    return this.makeGetRequest("/app-automate/projects.json", e);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(e, t) {
    return this.makeGetRequest("/app-automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project in the App Automate API.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project data.
   */
  updateProject(e, t, s) {
    return this.makePutRequest("/app-automate/projects/{projectId}.json", {
      ...s,
      params: {
        path: {
          projectId: e
        }
      },
      body: t
    });
  }
  /**
   * Deletes a project.
   * @param projectId The ID of the project to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(e, t) {
    return this.makeDeleteRequest("/app-automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(e, t) {
    return this.makeGetRequest("/app-automate/projects/{projectId}/badge_key", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the App Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of automation builds.
   */
  getBuilds(e, t) {
    return this.makeGetRequest("/app-automate/builds.json", {
      ...t,
      params: {
        query: e
      }
    }).then((s) => s.map((r) => r.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the build information, including the build details and associated sessions.
   */
  getBuild(e, t) {
    return this.makeGetRequest("/app-automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (r) => r.automation_session
      )
    }));
  }
  /**
   * Updates a build in the App Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build information.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the updated build.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(e, t, s) {
    return this.makePutRequest("/app-automate/builds/{buildId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((r) => {
      if ("error" in r)
        throw new k(r.error, { response: r });
      return r.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(e, t) {
    return this.makeDeleteRequest("/app-automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param data - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/app-automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: (r) => {
          const n = new FormData();
          return n.append("file", r.file, t.filename), n;
        },
        params: {
          path: {
            buildId: e
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param data - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/app-automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: (r) => {
          const n = new FormData();
          return n.append("file", r.file, t.filename), n;
        },
        params: {
          path: {
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the session details for a given session ID.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(e, t) {
    return this.makeGetRequest("/app-automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates the status of a session in the App Automate API.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session status.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the updated automation session.
   */
  updateSessionStatus(e, t, s) {
    return this.makePutRequest("/app-automate/sessions/{sessionId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((r) => r.automation_session);
  }
  /**
   * Deletes a session in the App Automate API.
   * @param sessionId - The ID of the session to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(e, t) {
    return this.makeDeleteRequest("/app-automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Retrieves the session logs for a specific build and session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the session logs.
   */
  getSessionLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/logs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the device logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the device logs.
   */
  getSessionDeviceLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/devicelogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appiumlogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the network logs for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/networklogs",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the app profiling data.
   */
  getSessionAppProfilingDataV1(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the API request.
   * @returns A promise that resolves with the app profiling data.
   */
  getSessionAppProfilingDataV2(e, t, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling/v2",
      {
        ...s,
        params: {
          path: {
            buildId: e,
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Uploads a media file to the App Automate API.
   *
   * @param data - The request body containing the media file to upload.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response of the API request.
   */
  uploadMediaFile(e, t) {
    return this.makePostRequest("/app-automate/upload-media", {
      ...t,
      body: e,
      bodySerializer: (s) => {
        const r = new FormData();
        return r.append("file", s.file, e.filename), s.custom_id && r.append("custom_id", s.custom_id), r;
      }
    });
  }
  /**
   * Retrieves the media files associated with the App Automate session.
   *
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of media files, or an empty array if no media files are found.
   */
  getMediaFiles(e) {
    return this.makeGetRequest(
      "/app-automate/recent_media_files",
      e
    ).then((t) => "message" in t ? [] : t);
  }
  /**
   * Retrieves media files by custom ID.
   * @param customId - The custom ID to filter media files.
   * @param options - Optional fetch options.
   * @returns A promise that resolves to an array of media files or an empty array if no media files are found.
   */
  getMediaFilesByCustomId(e, t) {
    return this.makeGetRequest("/app-automate/recent_media_files/{customId}", {
      ...t,
      params: {
        path: {
          customId: e
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the group's media files from the App Automate API.
   *
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of group media files, or an empty array if the response contains a "message" property.
   */
  getGroupMediaFiles(e) {
    return this.makeGetRequest(
      "/app-automate/recent_group_media",
      e
    ).then((t) => "message" in t ? [] : t);
  }
  /**
   * Deletes a media file from the app automate custom media.
   * @param mediaId The ID of the media file to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(e, t) {
    return this.makeDeleteRequest(
      "/app-automate/custom_media/delete/{mediaId}",
      {
        ...t,
        params: {
          path: {
            mediaId: e
          }
        }
      }
    );
  }
  /**
   * Uploads an Appium app to BrowserStack App Automate.
   *
   * @param data - The request body containing the app file or URL to be uploaded.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the upload request.
   */
  uploadAppiumApp(e, t) {
    return this.makePostRequest("/app-automate/upload", {
      ...t,
      body: e,
      bodySerializer: (s) => {
        const r = new FormData();
        return "file" in s ? r.append("file", s.file, e.filename) : r.append("url", s.url), s.custom_id && r.append("custom_id", s.custom_id), r;
      }
    });
  }
  /**
   * Retrieves the list of Appium apps from the App Automate API.
   *
   * @param options - Optional fetch options for customizing the request.
   * @returns A promise that resolves to an array of Appium apps, or an empty array if no apps are found.
   */
  getAppiumApps(e) {
    return this.makeGetRequest("/app-automate/recent_apps", e).then(
      (t) => "message" in t ? [] : t
    );
  }
  /**
   * Retrieves the Appium apps by custom ID.
   * @param customId The custom ID of the app.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Appium apps.
   */
  getAppiumAppsByCustomId(e, t) {
    return this.makeGetRequest("/app-automate/recent_apps/{customId}", {
      ...t,
      params: {
        path: {
          customId: e
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the list of App Automate apps for the group using the specified fetch options.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the list of group apps, or an empty array if there is a "message" property in the response data.
   */
  getAppiumGroupApps(e) {
    return this.makeGetRequest("/app-automate/recent_group_apps", e).then(
      (t) => "message" in t ? [] : t
    );
  }
  /**
   * Deletes an Appium app.
   *
   * @param appId - The ID of the app to delete.
   * @param options - Optional fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteAppiumApp(e, t) {
    return this.makeDeleteRequest("/app-automate/app/delete/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  /**
   * Uploads a Flutter app for App Automate.
   *
   * @param data - The request body containing the app file or URL and other optional parameters.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadFlutterApp(e, t, s) {
    return this.makePostRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/app" : "/app-automate/flutter-integration-tests/v2/ios/test-package",
      {
        ...s,
        body: t,
        bodySerializer: (r) => {
          const n = new FormData();
          return "file" in r ? n.append("file", r.file, t.filename) : n.append("url", r.url), r.custom_id && n.append("custom_id", r.custom_id), n;
        }
      }
    );
  }
  /**
   * Retrieves the list of Flutter apps for Android.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of Flutter apps, or an empty array if no apps are found.
   */
  getFlutterApps(e, t) {
    return this.makeGetRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps" : "/app-automate/flutter-integration-tests/v2/ios/test-packages",
      t
    ).then(
      (s) => "apps" in s ? s.apps : "test_packages" in s ? s.test_packages : []
    );
  }
  /**
   * Retrieves the Flutter app with the specified appId.
   * @param appId The ID of the Flutter app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Flutter app.
   */
  getFlutterApp(e, t, s) {
    return this.makeGetRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: t
          }
        }
      }
    ).then((r) => "app" in r ? r.app : r.test_package);
  }
  /**
   * Deletes a Flutter app from the BrowserStack App Automate service.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteFlutterApp(e, t, s) {
    return this.makeDeleteRequest(
      e === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: t
          }
        }
      }
    );
  }
  /**
   * Uploads an Espresso app to BrowserStack.
   *
   * @param data - The request body containing the app file or URL.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response from the server.
   */
  uploadEspressoApp(e, t) {
    return this.makePostRequest("/app-automate/espresso/v2/app", {
      ...t,
      body: e,
      bodySerializer: (s) => {
        const r = new FormData();
        return "file" in s ? r.append("file", s.file, e.filename) : r.append("url", s.url), s.custom_id && r.append("custom_id", s.custom_id), r;
      }
    });
  }
  /**
   * Retrieves the Espresso apps from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves to an array of Espresso apps.
   */
  getEspressoApps(e) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps", e).then(
      (t) => "apps" in t ? t.apps : []
    );
  }
  /**
   * Retrieves the Espresso app with the specified appId.
   * @param appId The ID of the Espresso app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Espresso app.
   */
  getEspressoApp(e, t) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an Espresso app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is deleted.
   */
  deleteEspressoApp(e, t) {
    return this.makeDeleteRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  /**
   * Uploads an XCUITest app to BrowserStack App Automate.
   *
   * @param data - The request body containing the XCUITest app file or URL.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the request.
   */
  uploadXCUITestApp(e, t) {
    return this.makePostRequest("/app-automate/xcuitest/v2/app", {
      ...t,
      body: e,
      bodySerializer: (s) => {
        const r = new FormData();
        return "file" in s ? r.append("file", s.file, e.filename) : r.append("url", s.url), s.custom_id && r.append("custom_id", s.custom_id), r;
      }
    });
  }
  /**
   * Retrieves the XCUITest apps available in the BrowserStack App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of XCUITest apps.
   */
  getXCUITestApps(e) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps", e).then(
      (t) => "apps" in t ? t.apps : []
    );
  }
  /**
   * Retrieves the XCUITest app with the specified appId.
   * @param appId The ID of the XCUITest app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the XCUITest app.
   */
  getXCUITestApp(e, t) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an XCUITest app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteXCUITestApp(e, t) {
    return this.makeDeleteRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...t,
      params: {
        path: {
          appId: e
        }
      }
    });
  }
  uploadDetoxAndroidApp(e, t, s) {
    return this.makePostRequest(
      e ? "/app-automate/detox/v2/android/app" : "/app-automate/detox/v2/android/app-client",
      {
        ...s,
        body: t,
        bodySerializer: (r) => {
          const n = new FormData();
          return "file" in r ? n.append("file", r.file, t.filename) : n.append("url", r.url), r.custom_id && n.append("custom_id", r.custom_id), n;
        }
      }
    );
  }
}
class ht extends H {
  /**
   * Constructs a new instance of the AutomateClient class.
   * @param options - Options to customize the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Recycles the automate key.
   * @param options The fetch options for the request.
   * @returns {} A promise that resolves to the response of the request.
   */
  recycleKey(e) {
    return this.makePutRequest("/automate/recycle_key.json", e);
  }
  /**
   * Retrieves the automate plan.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the automate plan.
   */
  getPlan(e) {
    return this.makeGetRequest("/automate/plan.json", e);
  }
  /**
   * Retrieves the list of available browsers for BrowserStack Automate.
   * @param options - Optional fetch options for customizing the request.
   * @returns A Promise that resolves to the list of available browsers.
   */
  getBrowsers(e) {
    return this.makeGetRequest("/automate/browsers.json", e);
  }
  /**
   * Retrieves the projects from the BrowserStack Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects data.
   */
  getProjects(e) {
    return this.makeGetRequest("/automate/projects.json", e);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(e, t) {
    return this.makeGetRequest("/automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project with the specified ID.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project details.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project.
   */
  updateProject(e, t, s) {
    return this.makePutRequest("/automate/projects/{projectId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Deletes a project with the specified ID.
   * @param projectId The ID of the project to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(e, t) {
    return this.makeDeleteRequest("/automate/projects/{projectId}.json", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(e, t) {
    return this.makeGetRequest("/automate/projects/{projectId}/badge_key", {
      ...t,
      params: {
        path: {
          projectId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the BrowserStack Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A Promise that resolves to an array of automation builds.
   */
  getBuilds(e, t) {
    return this.makeGetRequest("/automate/builds.json", {
      ...t,
      params: {
        query: e
      }
    }).then((s) => s.map((r) => r.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the build information.
   */
  getBuild(e, t) {
    return this.makeGetRequest("/automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (r) => r.automation_session
      )
    }));
  }
  /**
   * Updates a build in the BrowserStack Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated build data.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(e, t, s) {
    return this.makePutRequest("/automate/builds/{buildId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          buildId: e
        }
      }
    }).then((r) => {
      if ("error" in r)
        throw new k(r.error, { response: r });
      return r.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(e, t) {
    return this.makeDeleteRequest("/automate/builds/{buildId}.json", {
      ...t,
      params: {
        path: {
          buildId: e
        }
      }
    });
  }
  /**
   * Deletes multiple builds from the BrowserStack Automate API.
   * @param buildIds An array of build IDs to be deleted.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the delete request is successful.
   */
  deleteBuilds(e, t) {
    return this.makeDeleteRequest("/automate/builds", {
      ...t,
      params: {
        query: {
          "buildId[]": e
        }
      }
    });
  }
  /**
   * Retrieves the sessions associated with a specific build.
   *
   * @param buildId - The ID of the build.
   * @param query - Optional query parameters for filtering the sessions.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of automation sessions.
   */
  getSessions(e, t, s) {
    return this.makeGetRequest("/automate/builds/{buildId}/sessions.json", {
      ...s,
      params: {
        path: {
          buildId: e
        },
        query: t
      }
    }).then((r) => r.map((n) => n.automation_session));
  }
  /**
   * Retrieves the details of a specific session.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates an automate session.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated automation session.
   */
  updateSession(e, t, s) {
    return this.makePutRequest("/automate/sessions/{sessionId}.json", {
      ...s,
      body: t,
      params: {
        path: {
          sessionId: e
        }
      }
    }).then((r) => r.automation_session);
  }
  /**
   * Deletes a session by its session ID.
   * @param sessionId The ID of the session to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(e, t) {
    return this.makeDeleteRequest("/automate/sessions/{sessionId}.json", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Deletes the specified sessions.
   * @param sessionIds - An array of session IDs to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the delete request is complete.
   */
  deleteSessions(e, t) {
    return this.makeDeleteRequest("/automate/sessions", {
      ...t,
      params: {
        query: {
          "sessionId[]": e
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param data - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: (r) => {
          const n = new FormData();
          return n.append("file", r.file, t.filename), n;
        },
        params: {
          path: {
            buildId: e
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param data - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(e, t, s) {
    return this.makeCloudPostRequest(
      "/automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: t,
        bodySerializer: (r) => {
          const n = new FormData();
          return n.append("file", r.file, t.filename), n;
        },
        params: {
          path: {
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the logs of the session.
   */
  getSessionLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/logs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the network logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/networklogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Retrieves the console logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the console logs.
   */
  getSessionConsoleLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/consolelogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the Selenium logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the Selenium logs.
   */
  getSessionSeleniumLogs(e, t) {
    return this.makeCloudGetRequest(
      "/automate/sessions/{sessionId}/seleniumlogs",
      {
        ...t,
        params: {
          path: {
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/appiumlogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the telemetry logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the telemetry logs.
   */
  getSessionTelemetryLogs(e, t) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/telemetrylogs", {
      ...t,
      params: {
        path: {
          sessionId: e
        }
      }
    });
  }
  /**
   * Uploads a media file to the BrowserStack Automate API.
   *
   * @param data - The content of the media file to be uploaded, along with its filename.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the response of the API request.
   */
  uploadMediaFile(e, t) {
    return this.makePostRequest("/automate/upload-media", {
      ...t,
      body: e,
      bodySerializer: (s) => {
        const r = new FormData();
        return r.append("file", s.file, e.filename), r;
      }
    });
  }
  /**
   * Retrieves the recent media files from the BrowserStack Automate API.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves with the response from the API.
   */
  getMediaFiles(e) {
    return this.makeGetRequest("/automate/recent_media_files", e);
  }
  /**
   * Deletes a media file.
   * @param mediaId The ID of the media file to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(e, t) {
    return this.makeDeleteRequest("/automate/custom_media/delete/{mediaId}", {
      ...t,
      params: {
        path: {
          mediaId: e
        }
      }
    });
  }
}
class we extends H {
  /**
   * Constructs a new instance of the JSTestingClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://api.browserstack.com/5"
    });
  }
  getAccountStatus() {
    return this.makeGetRequest("/status");
  }
  /**
   * Retrieves a list of browsers from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of browsers.
   */
  getBrowsers(e, t) {
    return this.makeGetRequest("/browsers", {
      ...t,
      params: {
        query: {
          ...e,
          flat: typeof (e == null ? void 0 : e.flat) == "boolean" ? e.flat : !0
        }
      }
    });
  }
  createWorker(e, t) {
    return this.makePostRequest("/worker", {
      ...t,
      body: e
    });
  }
  getWorkers(e) {
    return this.makeGetRequest("/workers", e);
  }
  getWorker(e, t) {
    return this.makeGetRequest("/worker/{workedId}", {
      ...t,
      params: {
        path: {
          workedId: e
        }
      }
    });
  }
  deleteWorker(e, t) {
    return this.makeDeleteRequest("/worker/{workedId}", {
      ...t,
      params: {
        path: {
          workedId: e
        }
      }
    });
  }
}
var w = Uint8Array, O = Uint16Array, kt = Int32Array, Re = new w([
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1,
  1,
  1,
  1,
  2,
  2,
  2,
  2,
  3,
  3,
  3,
  3,
  4,
  4,
  4,
  4,
  5,
  5,
  5,
  5,
  0,
  /* unused */
  0,
  0,
  /* impossible */
  0
]), qe = new w([
  0,
  0,
  0,
  0,
  1,
  1,
  2,
  2,
  3,
  3,
  4,
  4,
  5,
  5,
  6,
  6,
  7,
  7,
  8,
  8,
  9,
  9,
  10,
  10,
  11,
  11,
  12,
  12,
  13,
  13,
  /* unused */
  0,
  0
]), gt = new w([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]), je = function(a, e) {
  for (var t = new O(31), s = 0; s < 31; ++s)
    t[s] = e += 1 << a[s - 1];
  for (var r = new kt(t[30]), s = 1; s < 30; ++s)
    for (var n = t[s]; n < t[s + 1]; ++n)
      r[n] = n - t[s] << 5 | s;
  return { b: t, r };
}, Se = je(Re, 2), Ie = Se.b, vt = Se.r;
Ie[28] = 258, vt[258] = 28;
var wt = je(qe, 0), bt = wt.b, ae = new O(32768);
for (var m = 0; m < 32768; ++m) {
  var _ = (m & 43690) >> 1 | (m & 21845) << 1;
  _ = (_ & 52428) >> 2 | (_ & 13107) << 2, _ = (_ & 61680) >> 4 | (_ & 3855) << 4, ae[m] = ((_ & 65280) >> 8 | (_ & 255) << 8) >> 1;
}
var W = function(a, e, t) {
  for (var s = a.length, r = 0, n = new O(e); r < s; ++r)
    a[r] && ++n[a[r] - 1];
  var o = new O(e);
  for (r = 1; r < e; ++r)
    o[r] = o[r - 1] + n[r - 1] << 1;
  var u;
  if (t) {
    u = new O(1 << e);
    var d = 15 - e;
    for (r = 0; r < s; ++r)
      if (a[r])
        for (var p = r << 4 | a[r], l = e - a[r], i = o[a[r] - 1]++ << l, c = i | (1 << l) - 1; i <= c; ++i)
          u[ae[i] >> d] = p;
  } else
    for (u = new O(s), r = 0; r < s; ++r)
      a[r] && (u[r] = ae[o[a[r] - 1]++] >> 15 - a[r]);
  return u;
}, K = new w(288);
for (var m = 0; m < 144; ++m)
  K[m] = 8;
for (var m = 144; m < 256; ++m)
  K[m] = 9;
for (var m = 256; m < 280; ++m)
  K[m] = 7;
for (var m = 280; m < 288; ++m)
  K[m] = 8;
var Ae = new w(32);
for (var m = 0; m < 32; ++m)
  Ae[m] = 5;
var yt = /* @__PURE__ */ W(K, 9, 1), Rt = /* @__PURE__ */ W(Ae, 5, 1), ee = function(a) {
  for (var e = a[0], t = 1; t < a.length; ++t)
    a[t] > e && (e = a[t]);
  return e;
}, A = function(a, e, t) {
  var s = e / 8 | 0;
  return (a[s] | a[s + 1] << 8) >> (e & 7) & t;
}, te = function(a, e) {
  var t = e / 8 | 0;
  return (a[t] | a[t + 1] << 8 | a[t + 2] << 16) >> (e & 7);
}, qt = function(a) {
  return (a + 7) / 8 | 0;
}, ie = function(a, e, t) {
  return (e == null || e < 0) && (e = 0), (t == null || t > a.length) && (t = a.length), new w(a.subarray(e, t));
}, jt = [
  "unexpected EOF",
  "invalid block type",
  "invalid length/literal",
  "invalid distance",
  "stream finished",
  "no stream handler",
  ,
  "no callback",
  "invalid UTF-8 data",
  "extra field too long",
  "date not in range 1980-2099",
  "filename too long",
  "stream finishing",
  "invalid zip data"
  // determined by unknown compression method
], q = function(a, e, t) {
  var s = new Error(e || jt[a]);
  if (s.code = a, Error.captureStackTrace && Error.captureStackTrace(s, q), !t)
    throw s;
  return s;
}, St = function(a, e, t, s) {
  var r = a.length, n = s ? s.length : 0;
  if (!r || e.f && !e.l)
    return t || new w(0);
  var o = !t, u = o || e.i != 2, d = e.i;
  o && (t = new w(r * 3));
  var p = function(de) {
    var fe = t.length;
    if (de > fe) {
      var he = new w(Math.max(fe * 2, de));
      he.set(t), t = he;
    }
  }, l = e.f || 0, i = e.p || 0, c = e.b || 0, g = e.l, b = e.d, y = e.m, G = e.n, P = r * 8;
  do {
    if (!g) {
      l = A(a, i, 1);
      var B = A(a, i + 1, 3);
      if (i += 3, B)
        if (B == 1)
          g = yt, b = Rt, y = 9, G = 5;
        else if (B == 2) {
          var f = A(a, i, 31) + 257, z = A(a, i + 10, 15) + 4, I = f + A(a, i + 5, 31) + 1;
          i += 14;
          for (var v = new w(I), E = new w(19), R = 0; R < z; ++R)
            E[gt[R]] = A(a, i + R * 3, 7);
          i += z * 3;
          for (var oe = ee(E), De = (1 << oe) - 1, Ge = W(E, oe, 1), R = 0; R < I; ) {
            var ue = Ge[A(a, i, De)];
            i += ue & 15;
            var h = ue >> 4;
            if (h < 16)
              v[R++] = h;
            else {
              var $ = 0, N = 0;
              for (h == 16 ? (N = 3 + A(a, i, 3), i += 2, $ = v[R - 1]) : h == 17 ? (N = 3 + A(a, i, 7), i += 3) : h == 18 && (N = 11 + A(a, i, 127), i += 7); N--; )
                v[R++] = $;
            }
          }
          var le = v.subarray(0, f), T = v.subarray(f);
          y = ee(le), G = ee(T), g = W(le, y, 1), b = W(T, G, 1);
        } else
          q(1);
      else {
        var h = qt(i) + 4, C = a[h - 4] | a[h - 3] << 8, U = h + C;
        if (U > r) {
          d && q(0);
          break;
        }
        u && p(c + C), t.set(a.subarray(h, U), c), e.b = c += C, e.p = i = U * 8, e.f = l;
        continue;
      }
      if (i > P) {
        d && q(0);
        break;
      }
    }
    u && p(c + 131072);
    for (var Pe = (1 << y) - 1, xe = (1 << G) - 1, Q = i; ; Q = i) {
      var $ = g[te(a, i) & Pe], L = $ >> 4;
      if (i += $ & 15, i > P) {
        d && q(0);
        break;
      }
      if ($ || q(2), L < 256)
        t[c++] = L;
      else if (L == 256) {
        Q = i, g = null;
        break;
      } else {
        var pe = L - 254;
        if (L > 264) {
          var R = L - 257, M = Re[R];
          pe = A(a, i, (1 << M) - 1) + Ie[R], i += M;
        }
        var Y = b[te(a, i) & xe], Z = Y >> 4;
        Y || q(3), i += Y & 15;
        var T = bt[Z];
        if (Z > 3) {
          var M = qe[Z];
          T += te(a, i) & (1 << M) - 1, i += M;
        }
        if (i > P) {
          d && q(0);
          break;
        }
        u && p(c + 131072);
        var ce = c + pe;
        if (c < T) {
          var me = n - T, Ce = Math.min(T, ce);
          for (me + c < 0 && q(3); c < Ce; ++c)
            t[c] = s[me + c];
        }
        for (; c < ce; ++c)
          t[c] = t[c - T];
      }
    }
    e.l = g, e.p = Q, e.b = c, e.f = l, g && (l = 1, e.m = y, e.d = b, e.n = G);
  } while (!l);
  return c != t.length && o ? ie(t, 0, c) : t.subarray(0, c);
}, It = /* @__PURE__ */ new w(0), x = function(a, e) {
  return a[e] | a[e + 1] << 8;
}, D = function(a, e) {
  return (a[e] | a[e + 1] << 8 | a[e + 2] << 16 | a[e + 3] << 24) >>> 0;
}, se = function(a, e) {
  return D(a, e) + D(a, e + 4) * 4294967296;
};
function At(a, e) {
  return St(a, { i: 2 }, e && e.out, e && e.dictionary);
}
var ne = typeof TextDecoder < "u" && /* @__PURE__ */ new TextDecoder(), Dt = 0;
try {
  ne.decode(It, { stream: !0 }), Dt = 1;
} catch {
}
var Gt = function(a) {
  for (var e = "", t = 0; ; ) {
    var s = a[t++], r = (s > 127) + (s > 223) + (s > 239);
    if (t + r > a.length)
      return { s: e, r: ie(a, t - 1) };
    r ? r == 3 ? (s = ((s & 15) << 18 | (a[t++] & 63) << 12 | (a[t++] & 63) << 6 | a[t++] & 63) - 65536, e += String.fromCharCode(55296 | s >> 10, 56320 | s & 1023)) : r & 1 ? e += String.fromCharCode((s & 31) << 6 | a[t++] & 63) : e += String.fromCharCode((s & 15) << 12 | (a[t++] & 63) << 6 | a[t++] & 63) : e += String.fromCharCode(s);
  }
};
function Pt(a, e) {
  if (e) {
    for (var t = "", s = 0; s < a.length; s += 16384)
      t += String.fromCharCode.apply(null, a.subarray(s, s + 16384));
    return t;
  } else {
    if (ne)
      return ne.decode(a);
    var r = Gt(a), n = r.s, t = r.r;
    return t.length && q(8), n;
  }
}
var xt = function(a, e) {
  return e + 30 + x(a, e + 26) + x(a, e + 28);
}, Ct = function(a, e, t) {
  var s = x(a, e + 28), r = Pt(a.subarray(e + 46, e + 46 + s), !(x(a, e + 8) & 2048)), n = e + 46 + s, o = D(a, e + 20), u = t && o == 4294967295 ? Tt(a, n) : [o, D(a, e + 24), D(a, e + 42)], d = u[0], p = u[1], l = u[2];
  return [x(a, e + 10), d, p, r, n + x(a, e + 30) + x(a, e + 32), l];
}, Tt = function(a, e) {
  for (; x(a, e) != 1; e += 4 + x(a, e + 2))
    ;
  return [se(a, e + 12), se(a, e + 4), se(a, e + 20)];
};
function _t(a, e) {
  for (var t = {}, s = a.length - 22; D(a, s) != 101010256; --s)
    (!s || a.length - s > 65558) && q(13);
  var r = x(a, s + 8);
  if (!r)
    return {};
  var n = D(a, s + 16), o = n == 4294967295 || r == 65535;
  if (o) {
    var u = D(a, s - 12);
    o = D(a, u) == 101075792, o && (r = D(a, u + 32), n = D(a, u + 48));
  }
  for (var d = e && e.filter, p = 0; p < r; ++p) {
    var l = Ct(a, n, o), i = l[0], c = l[1], g = l[2], b = l[3], y = l[4], G = l[5], P = xt(a, G);
    n = y, (!d || d({
      name: b,
      size: c,
      originalSize: g,
      compression: i
    })) && (i ? i == 8 ? t[b] = At(a.subarray(P, P + c), { out: new w(g) }) : q(14, "unknown compression type " + i) : t[b] = ie(a, P, P + c));
  }
  return t;
}
class Bt extends H {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://www.browserstack.com",
      usernameOptional: !0
    });
    F(this, "authToken");
    const s = (t == null ? void 0 : t.key) ?? re.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new k("Missing options.key");
    this.authToken = s;
  }
  /**
   * Retrieves a list of recent Local binary instances from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of active Local instances.
   */
  getBinaryInstances(t, s) {
    return this.makeGetRequest("/local/v1/list", {
      ...s,
      params: {
        query: {
          ...t,
          auth_token: this.authToken
        }
      }
    }).then((r) => r.instances);
  }
  /**
   * Retrieves details of a Local binary instance from the server.
   *
   * @param localInstanceId The ID of the local binary instance to retrieve.
   * @param query Optional query parameters for the request.
   * @param options Optional fetch options for the request.
   * @returns A promise that resolves to the retrieved local binary instance.
   * @throws {BrowserStackError} If no local binary instance is found with the specified ID.
   */
  getBinaryInstance(t, s, r) {
    return this.makeGetRequest("/local/v1/{localInstanceId}", {
      ...r,
      params: {
        path: {
          localInstanceId: t
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((n) => {
      if (!n.instances.length)
        throw new k(
          `No Local binary instance found with id "${t}"`
        );
      return n.instances[0];
    });
  }
  /**
   * Disconnects a binary instance.
   *
   * @param localInstanceId - The ID of the local binary instance to disconnect.
   * @param query - Optional query parameters for the request.
   * @param options - Optional API fetch options.
   * @returns A promise that resolves to a string representing the message from the server.
   */
  disconnectBinaryInstance(t, s, r) {
    return this.makeDeleteRequest("/local/v1/{localInstanceId}", {
      ...r,
      params: {
        path: {
          localInstanceId: t
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((n) => n.message);
  }
  /**
   * Downloads the BrowserStackLocal binary for the specified operating system architecture and saves it to the specified file path.
   * Note that the file is downloaded to memory for the unzip operation.
   * If the file is large, this method may fail with an out of memory error.
   * This method is intended for use in Node.js environments and will fail in the browser.
   *
   * @internal
   * @param osArch - The operating system architecture for which to download the binary.
   * @param dirPath - The file path where the binary will be saved.
   * @param filenamePrefix - The prefix for the downloaded binary file name inside the ZIP file. Default is "BrowserStackLocal".
   * @param fileMode - The file mode to set for the downloaded binary file. Default is 0o755.
   * @param options - Additional options for the API fetch request.
   * @returns A Promise that resolves when the binary is successfully downloaded and saved.
   */
  downloadBinary(t, s = "BrowserStackLocal", r) {
    return this.sdk.GET("/browserstack-local/BrowserStackLocal-{osArch}.zip", {
      ...r,
      params: {
        path: {
          osArch: t
        }
      },
      parseAs: "arrayBuffer"
    }).then(({ data: n }) => {
      if (!n)
        throw new k(
          `Failed to download BrowserStackLocal-${t}.zip: Unexpected response.`
        );
      const o = _t(new Uint8Array(n), {
        filter: (p) => p.name.startsWith(s)
      }), u = Object.keys(o);
      if (!u.length)
        throw new k(
          `Local binary not found in BrowserStackLocal-${t}.zip`
        );
      return { content: o[u[0]], filename: u[0] };
    }).catch((n) => {
      throw n instanceof k ? n : new k(
        `Failed to write local binary to disk: ${n.message}: ${n.stack}`
      );
    });
  }
}
class Et extends H {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://www.browserstack.com"
    });
  }
  /**
   * Retrieves the list of available browsers for taking screenshots.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getBrowsers(e) {
    return this.makeGetRequest("/screenshots/browsers.json", e);
  }
  /**
   * Creates a new screenshots job.
   * @param body - The request body for creating the job.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  createJob(e, t) {
    return this.makePostRequest("/screenshots", {
      ...t,
      body: e
    });
  }
  /**
   * Retrieves the details of a screenshots job.
   * @param jobId - The ID of the job to retrieve.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getJob(e, t) {
    return this.makeGetRequest("/screenshots/{jobId}.json", {
      ...t,
      params: {
        path: {
          jobId: e
        }
      }
    });
  }
}
const Ut = {
  AutomateClient: ht,
  ScreenshotsClient: Et,
  AppAutomateClient: ft,
  JSTestingClient: we,
  /**
   * Backwards compatibility alias for {@link JSTestingClient}.
   */
  Client: we,
  LocalTestingClient: Bt
};
export {
  Ut as BrowserStack
};
